import { RecipientStatusObject, RecipientStatusObjectData, SenderStatusObject, StatusObject, WrapperData } from "../types";
export declare const SENDER_CLASS_NAME = "SenderStatusObject";
export declare const RECIPIENT_CLASS_NAME = "RecipientStatusObject";
export declare const STATUS_FILE_PREFIX = "bs_";
export declare const MIME_SIGNATURE_HASHING_ALGORITHMS: {
    MIME: string;
    PARTS: string;
};
export declare const EMAIL_VENDORS: {
    GMAIL: string;
    OUTLOOK: string;
    ROUNDCUBE: string;
    GENERIC_MIME: string;
};
declare class StatusesService {
    static SENDER_CLASS_NAME: string;
    static RECIPIENT_CLASS_NAME: string;
    static EMAIL_VENDORS: {
        GMAIL: string;
        OUTLOOK: string;
        ROUNDCUBE: string;
        GENERIC_MIME: string;
    };
    static MIME_SIGNATURE_HASHING_ALGORITHMS: {
        MIME: string;
        PARTS: string;
    };
    static STATUS_FILE_PREFIX: string;
    encodeSenderStatusObject(senderStatusObject: SenderStatusObject): ArrayBuffer;
    decodeSenderStatusObject(bytes: ArrayBuffer | string): SenderStatusObject;
    encodeAndWrapSenderStatusObject(senderStatusObject: SenderStatusObject): ArrayBuffer;
    encodeRecipientStatusObject(data: RecipientStatusObject): ArrayBuffer;
    decodeRecipientStatusObject(bytes: string | ArrayBuffer): RecipientStatusObject;
    encodeAndWrapRecipientStatusObject(data: RecipientStatusObject): ArrayBuffer;
    encodeRecipientStatusData(data: RecipientStatusObjectData): ArrayBuffer;
    decodeRecipientStatusData(bytes: ArrayBuffer): RecipientStatusObjectData;
    encodeSenderWrapperData(statusObjectBytes: ArrayBuffer | string): ArrayBuffer;
    encodeRecipientWrapperData(statusObjectBytes: ArrayBuffer | string): ArrayBuffer;
    encodeWrapperData(data: ArrayBuffer | string, className: string, version?: number): ArrayBuffer;
    decodeWrapperData(bytes: ArrayBuffer | string): WrapperData;
    decodeStatusObject(wrapperDataBytes: ArrayBuffer | string): {
        className: string;
        statusObject: StatusObject;
    };
}
export default StatusesService;
