export interface AeternityAPITxData {
  block_hash: string;
  block_height: number;
  hash: string;
  signatures: Array<string>;
  tx: {
    abi_version: number;
    amount: number;
    call_data: string;
    caller_id: string;
    contract_id: string;
    fee: number;
    gas: number;
    gas_price: number;
    nonce: number;
    type: string;
    version: number;
  };
}

export interface AeternityAPIMicroBLock {
  hash: string;
  height: number;
  pof_hash: string;
  prev_hash: string;
  prev_key_hash: string;
  signature: string;
  state_hash: string;
  time: number;
  transactions: { [key: string]: AeternityAPITxData };
}

export interface AeternityAPIBlockData {
  beneficiary: string;
  hash: string;
  height: number;
  info: string;
  microBlock: Array<AeternityAPIMicroBLock>;
  miner: string;
  nonce: number;
  pow: Array<number>;
  prev_hash: string;
  prev_key_hash: string;
  state_hash: string;
  target: number;
  time: number;
  version: number;
}

export interface AeternityAPICurrentHeight {
  height: number;
}

export interface AeternityAPIContractData {
  arguments: [
    {
      value: [
        {
          key: { value };
          val: { value };
        }
      ];
    }
  ];
}

export interface AeternityAPIBlockRange {
  data: Array<AeternityAPIBlockData>;
}
