export const VERIFICATION_ERROR = "VERIFICATION_ERROR";

export const SEVERITY_INFO = 0;
export const SEVERITY_WARNING = 1;
export const SEVERITY_FAILURE = 2;

class VerificationError extends Error {
  public type: string;
  public severity: number = SEVERITY_FAILURE;

  static SEVERITY_INFO = SEVERITY_INFO;
  static SEVERITY_WARNING = SEVERITY_WARNING;
  static SEVERITY_FAILURE = SEVERITY_FAILURE;

  static TYPES = {
    GENERAL_ERROR: "GENERAL_ERROR",
    TRANSACTION_PENDING: "TRANSACTION_PENDING",
  };

  constructor(
    message: string,
    type = VerificationError.TYPES.GENERAL_ERROR,
    severity?: number
  ) {
    super(message);
    this.name = VERIFICATION_ERROR;
    this.type = type;
    this.severity = typeof severity === "number" ? severity : SEVERITY_FAILURE;
  }
}

export default VerificationError;
